-- $Header:   //ARCHIVE/Archive/DB/sql/MessageAlertStatePriFix.sqv   1.0   Mar 16 2001 08:17:16   BRENT  $
--
-- MessageAlertStatePriFix.sql
--
-- This module is a part of the fix for defect #71244:
-- abstract      False child event left after two non-green messages
--


USE Object
GO

-- Add mesg_id column to LastMessageAlertStatePri table
IF NOT EXISTS (SELECT * FROM syscolumns WHERE id = OBJECT_ID('LastMessageAlertStatePri') AND name = 'mesg_id')
BEGIN
  ALTER TABLE LastMessageAlertStatePri ADD
    mesg_id    ObjID NOT NULL DEFAULT 0
END

-- Get rid of update trigger on CurrentMessageAlertStatePri table that was an earlier attempt
-- at fixing defect.
IF EXISTS (SELECT * FROM sysobjects WHERE name = 'tU_CurrentMessageAlertStatePri' AND type = 'TR')
  DROP TRIGGER tU_CurrentMessageAlertStatePri
GO
