-- $Header:   //ARCHIVE/Archive/DB/SQL/SnaLocalTopoClassLink.sqv   1.2   Mar 13 2001 12:05:26   BRENT  $
--
-- SnaLocalTopoClassLink.sql
--
-- Adds the RODMClassLinkMap entries that maps SnaLocalTopo objects that have links to 
-- interchangeNode objects to the nnLocalTopology class (cid='NNLT') and
-- migrationDataHost objects to the enLocalTopology class (cid='ENLT').

USE RODMLoad
GO

IF NOT EXISTS 
(
  SELECT * 
  FROM RODMClassLinkMap
  WHERE
    SrcClass = 'snaLocalTopo'
    AND SrcField = 'member'
    AND DstClass = 'interchangeNode'
    AND DstField = 'memberOf'
)
  INSERT INTO RODMClassLinkMap (SrcClass, SrcField, DstClass, DstField, cid, direction, priority )
    VALUES ( 'snaLocalTopo', 'member', 'interchangeNode', 'memberOf', 'NNLT', 1, 20 )
GO

IF NOT EXISTS 
(
  SELECT * 
  FROM RODMClassLinkMap
  WHERE
    SrcClass = 'snaLocalTopo'
    AND SrcField = 'member'
    AND DstClass = 'migrationDataHost'
    AND DstField = 'memberOf'
)
  INSERT INTO RODMClassLinkMap (SrcClass, SrcField, DstClass, DstField, cid, direction, priority )
    VALUES ( 'snaLocalTopo', 'member', 'migrationDataHost', 'memberOf', 'ENLT', 1, 0 )
GO

-- Get rid of 'bad' instance data in RODM database

DELETE FROM RODM..RODMManagedLink WHERE src_cid = 'SNLT' OR dst_cid = 'SNLT'
DELETE FROM RODM..RODMManagedObject WHERE _RODMClass = 'snaLocalTopo' AND cid = 'SNLT'

GO
