-- $Header:   //ARCHIVE/Archive/DB/sql/asisp_setmesgalertstatepri.sqv   1.0   Mar 16 2001 08:23:22   BRENT  $
--
-- asisp_setmesgalertstatepri.sql
--

USE Object
GO


---------------------------------------------------------------------------------------------------
-- asisp_setmesgalertstatepri
PRINT 'Creating procedure asisp_setmesgalertstatepri'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_setmesgalertstatepri' AND type = 'P')
  DROP PROCEDURE asisp_setmesgalertstatepri
GO

-- $Archive:   //ARCHIVE/Archive/DB/sql/asisp_setmesgalertstatepri.sqv  $
-- $Revision:   1.0  $
-- $Date:   Mar 16 2001 08:23:22  $
-- $Author:   BRENT  $
-- Updates the LastMessageAlertStatePri record for the specified cid/id with the new message id,
-- alert state, and priority. Will create a record if none already exists.
CREATE PROCEDURE asisp_setmesgalertstatepri
  @cid          ClassID,
  @id           ObjID,
  @mesg_id      ObjID,
  @AlertState   INT,
  @Priority     INT
AS
  -- Standard transaction logic
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION asisp_setmesgalertstatepri
  ELSE
    SAVE TRANSACTION asisp_setmesgalertstatepri

  -- Update the LastMessageAlertStatePri table
  UPDATE LastMessageAlertStatePri SET
    AlertState = @AlertState,
    Priority   = @Priority,
    mesg_id    = @mesg_id
  WHERE
    cid = @cid
    AND id = @id
  IF @@ROWCOUNT = 0
    INSERT LastMessageAlertStatePri(cid, id, mesg_id, AlertState, Priority)
      VALUES ( @cid, @id, @mesg_id, @AlertState, @Priority )

  -- Standard transaction logic
  IF @tcount = 0
    COMMIT TRANSACTION asisp_setmesgalertstatepri
GO
