-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/pa_clearObjectLoadLog.sqv   1.0   May 30 2001 12:05:22   BRENT  $
--
-- pa_clearObjectLoadLog.sql
--
-- Module Description
--   Defines the pa_clearObjectLoadLog stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- pa_clearObjectLoadLog
PRINT 'Creating procedure pa_clearObjectLoadLog'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'pa_clearObjectLoadLog' AND type = 'P')
  DROP PROCEDURE pa_clearObjectLoadLog
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/pa_clearObjectLoadLog.sqv  $
-- $Revision:   1.0  $
-- $Date:   May 30 2001 12:05:22  $
-- $Author:   BRENT  $
-- Called by propagation agent at initialization to delete all of the records for the particular PA
-- instance from the PAObjectLoadLog table.
CREATE PROCEDURE pa_clearObjectLoadLog
  @pa_id        ObjID
AS
  DECLARE @rc INT
  DELETE PAObjectLoadLog WHERE pa_id = @pa_id
  SET @rc = @@ROWCOUNT
  RAISERROR('pa_clearObjectLoadLog @pa_id=%d: deleted %d row(s)', 2, 1, @pa_id, @rc)
GO
