-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/pa_loadPropagationObject.sqv   1.1   May 30 2001 13:43:50   BRENT  $
--
-- pa_loadPropagationObject.sql
--
-- Module Description
--   Defines the pa_loadPropagationObject stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- pa_loadPropagationObject
PRINT 'Creating procedure pa_loadPropagationObject'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'pa_loadPropagationObject' AND type = 'P')
  DROP PROCEDURE pa_loadPropagationObject
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/pa_loadPropagationObject.sqv  $
-- $Revision:   1.1  $
-- $Date:   May 30 2001 13:43:50  $
-- $Author:   BRENT  $
-- Called by propagation agent to load an individual object that has received an event
CREATE PROCEDURE pa_loadPropagationObject
  @pa_id  ObjID,
  @cid    ClassID,
  @id     ObjID
AS
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION asisp_loadPropagationObject
  ELSE
    SAVE TRANSACTION asisp_loadPropagationObject

  CREATE TABLE #PropagationObject
  (
    cid             ClassID        PRIMARY KEY (cid, id),
    id              ObjID,
    MESGAlertState  INT NULL,
    MESGPriority    INT NULL,
    AlertState      INT NULL,
    Priority        INT NULL,
    CurrentState    INT NULL,
    DesiredState    INT NULL,
    phy_cid         ClassID NULL,
    phy_id          ObjID NULL
  )

  INSERT #PropagationObject SELECT @cid, @id, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL

  UPDATE o SET MESGAlertState = p.AlertState, MESGPriority = p.Priority
  FROM #PropagationObject AS o, LastMessageAlertStatePri AS p
  WHERE p.cid = @cid AND p.id = @id

  IF @cid = 'LOB'
    UPDATE o SET
      phy_cid = l.phy_cid, 
      phy_id = l.phy_id
    FROM #PropagationObject AS o JOIN lob_link AS l ON l.dst_id = o.id

  DECLARE @cname NVARCHAR(24), @id_str NVARCHAR(9), @flag_direct_containment TINYINT
  SELECT @cname = cname, @flag_direct_containment = flag_direct_containment, @id_str = CAST(@id AS NVARCHAR(9))
  FROM obj_class
  WHERE cid = @cid

  EXEC("
  UPDATE o SET 
    AlertState=_AlertStateID,
    Priority=_PriorityID,
    CurrentState=_CurrentStateID,
    DesiredState=_DesiredStateID
  FROM " + @cname + "_V AS i JOIN #PropagationObject AS o ON o.cid = '" + @cid + "' AND o.id = i.id
    LEFT OUTER JOIN containment AS c ON c.dst_cid = o.cid AND dst_id = o.id AND c.src_cid NOT IN ('BUSC', 'LOBC')
  ")

  SELECT * FROM #PropagationObject
  IF NOT EXISTS (SELECT * FROM PAObjectLoadLog WHERE pa_id = @pa_id AND cid = @cid AND id = @id)
    INSERT INTO PAObjectLoadLog(pa_id, cid, id) SELECT @pa_id, @cid, @id
  ELSE
    RAISERROR('asisp_loadPropagationObject: PAObjectLoadLog already has record for pa_id=%d, cid=''%s'', id=%d', 2, 1,
              @pa_id, @cid, @id)

  IF @tcount = 0
    COMMIT TRANSACTION asisp_loadPropagationObject
GO
