-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/pa_prefetchPendingEventObjects.sqv   1.1   May 30 2001 12:36:40   BRENT  $
--
-- pa_prefetchPendingEventObjects.sql
--
-- Module Description:
--   Defines the pa_prefetchPendingEventObjects stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- pa_prefetchPendingEventObjects
PRINT 'Creating procedure pa_prefetchPendingEventObjects'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'pa_prefetchPendingEventObjects' AND type = 'P')
  DROP PROCEDURE pa_prefetchPendingEventObjects
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/pa_prefetchPendingEventObjects.sqv  $
-- $Revision:   1.1  $
-- $Date:   May 30 2001 12:36:40  $
-- $Author:   BRENT  $
-- Called by propagation agent to perform lookahead fetch of the objects that have received events
CREATE PROCEDURE pa_prefetchPendingEventObjects
  @pa_id        ObjID,
  @last_eventno INT,
  @max_events   INT
AS
  DECLARE @max_eventno INT
  SELECT @max_eventno = max(eventno) FROM PendingEvent 
  WHERE eventno BETWEEN @last_eventno+1 AND @last_eventno+@max_events

  SELECT @max_eventno AS max_eventno, eventno AS last_dispatched_eventno FROM LastProcessedEvent

  CREATE TABLE #PropagationObject
  (
    cid             ClassID        PRIMARY KEY (cid, id),
    id              ObjID,
    MESGAlertState  INT NULL,
    MESGPriority    INT NULL,
    AlertState      INT NULL,
    Priority        INT NULL,
    CurrentState    INT NULL,
    DesiredState    INT NULL,
--    ParentCID       ClassID NULL,
--    ParentID        INT NULL,
    phy_cid         ClassID NULL,
    phy_id          ObjID NULL
  )
  INSERT #PropagationObject
    SELECT DISTINCT cid, id, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL--, NULL, NULL
    FROM PendingEvent AS pe
    WHERE
      eventno BETWEEN @last_eventno+1 AND @max_eventno
      AND cid IS NOT NULL
      AND NOT EXISTS
      (
        SELECT * FROM PAObjectLoadLog AS l WHERE l.pa_id = @pa_id AND l.cid = pe.cid AND l.id = pe.id
      )
  IF @@ROWCOUNT > 0
  BEGIN
    UPDATE o SET MESGAlertState = p.AlertState, MESGPriority = p.Priority
    FROM #PropagationObject AS o JOIN LastMessageAlertStatePri AS p ON p.cid = o.cid AND p.id = o.id

    UPDATE o SET
      phy_cid = l.phy_cid, 
      phy_id = l.phy_id
    FROM #PropagationObject AS o JOIN lob_link AS l ON l.dst_id = o.id
    WHERE cid = 'LOB'

    DECLARE @cid ClassID, @cname NVARCHAR(24)--, @flag_direct_containment
    DECLARE oc CURSOR FOR
      SELECT DISTINCT c.cid, c.cname--, c.flag_direct_containment
      FROM #PropagationObject AS o JOIN obj_class AS c ON c.cid = o.cid
    OPEN oc
    FETCH NEXT FROM oc INTO @cid, @cname--, @flag_direct_containment
    WHILE @@FETCH_STATUS <> -1
    BEGIN
      DECLARE @sql NVARCHAR(500)
      SET @sql = "
        UPDATE o SET 
          AlertState = i._AlertStateID,
          Priority = i._PriorityID,
          CurrentState = i._CurrentStateID,
          DesiredState = i._DesiredStateID"
--      IF @flag_direct_containment = 1
--        SET @sql = @sql + ",
--          ParentCID = i._ParentCID,
--          ParentID = i._ParentID"
      SET @sql = @sql + "
        FROM #PropagationObject AS o JOIN " + @cname + "_V AS i ON i.id = o.id
        WHERE o.cid = '" + @cid + "'"
      EXEC(@sql)
      FETCH NEXT FROM oc INTO @cid, @cname--, @flag_direct_containment
    END
    DEALLOCATE oc

    INSERT INTO PAObjectLoadLog(pa_id, cid, id)
      SELECT @pa_id, p.cid, p.id
      FROM #PropagationObject AS p
      WHERE NOT EXISTS
      (
        SELECT * FROM PAObjectLoadLog AS l WHERE l.pa_id = @pa_id AND l.cid = p.cid AND l.id = p.id
      )

    SELECT * FROM #PropagationObject
  END
GO
